/*
'' ============================================================================================
'' 项目名称：风越项目范例ASPX普通三层结构
'' 项目版本：V1.0
'' 项目描述：风越项目范例，用于建立ASPX普通三层结构
'' 文件名称：DAL_DEPARTMENT.cs
'' 文件描述：数据访问层 DEPARTMENT
'' 公司名称：中极网盛
'' 开发人员：刘怒
'' 创建日期：2008-12-25 20:23:50
'' 修订日期：2009-01-13 05:50:58
'' 版权信息：Copyright (C) 2008

'' 项目升级时需读取以下生成工具的版权信息
'' 生成工具：风越代码生成器 [FireCode Creator]
'' 当前版本：企业版 V1.5
'' 官方网站：http://www.sino8848.com
'' ============================================================================================
*/

using System;
using System.Text;
using System.Data;

using System.Data.SqlClient;

using FypSystem.DBManager;

namespace Fyp_3TierCommon.DAL
{
    /// <summary>
    /// 数据访问类DEPARTMENT。
    /// </summary>
    public class DAL_DEPARTMENT
    {
        public DAL_DEPARTMENT()
        {
        }

        #region  记录是否存在
        /// <summary>
        /// 记录是否存在
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        /// <returns></returns>
        public bool Exists(int? DEPARTMENT_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(*) from [DEPARTMENT] ");
            strSql.Append("where [DEPARTMENT_ID] = @DEPARTMENT_ID");

            SqlParameter[] arrParameters = new SqlParameter[1];

            arrParameters[0] = new SqlParameter("@DEPARTMENT_ID", SqlDbType.Int, 10);
            arrParameters[0].Value = DEPARTMENT_ID;

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                return Convert.ToBoolean(dbManager.ExecScalar(strSql.ToString(), arrParameters));
            }
        }
        #endregion

        #region 增加数据
        /// <summary>
        /// 增加数据
        /// </summary>
        /// <param name="model">DEPARTMENT实体对象</param>
        public void Add(Fyp_3TierCommon.Model.Model_DEPARTMENT model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into [DEPARTMENT] (");
            strSql.Append("COMPANY_ID, DEPARTMENT_NAME");
            strSql.Append(") values (");
            strSql.Append("@COMPANY_ID, @DEPARTMENT_NAME");
            strSql.Append(")");

            SqlParameter[] arrParameters = new SqlParameter[2];

            arrParameters[0] = new SqlParameter("@COMPANY_ID", SqlDbType.Int, 10);
            arrParameters[0].Value = model.COMPANY_ID;

            arrParameters[1] = new SqlParameter("@DEPARTMENT_NAME", SqlDbType.NVarChar, 200);
            arrParameters[1].Value = model.DEPARTMENT_NAME;

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                dbManager.ExecNonQuery(strSql.ToString(), arrParameters);
            }
        }
        #endregion

        #region 更新数据
        /// <summary>
        /// 更新数据
        /// </summary>
        /// <param name="model">DEPARTMENT实体对象</param>
        public void Update(Fyp_3TierCommon.Model.Model_DEPARTMENT model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update [DEPARTMENT] set ");

            strSql.Append("COMPANY_ID=@COMPANY_ID");
            strSql.Append("DEPARTMENT_NAME=@DEPARTMENT_NAME");
            strSql.Append(" where [DEPARTMENT_ID] = @DEPARTMENT_ID");

            SqlParameter[] arrParameters = new SqlParameter[3];

            arrParameters[0] = new SqlParameter("@DEPARTMENT_ID", SqlDbType.Int, 10);
            arrParameters[0].Value = model.DEPARTMENT_ID;

            arrParameters[1] = new SqlParameter("@COMPANY_ID", SqlDbType.Int, 10);
            arrParameters[1].Value = model.COMPANY_ID;

            arrParameters[2] = new SqlParameter("@DEPARTMENT_NAME", SqlDbType.NVarChar, 200);
            arrParameters[2].Value = model.DEPARTMENT_NAME;

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                dbManager.ExecNonQuery(strSql.ToString(), arrParameters);
            }
        }
        #endregion

        #region 删除数据
        /// <summary>
        /// 删除数据
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        public void Delete(int? DEPARTMENT_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from [DEPARTMENT] ");
            strSql.Append(" where [DEPARTMENT_ID] = @DEPARTMENT_ID");

            SqlParameter[] arrParameters = new SqlParameter[1];

            arrParameters[0] = new SqlParameter("@DEPARTMENT_ID", SqlDbType.Int, 10);
            arrParameters[0].Value = DEPARTMENT_ID;

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                dbManager.ExecNonQuery(strSql.ToString(), arrParameters);
            }
        }
        #endregion

        #region 获取对象实体
        /// <summary>
        /// 获取对象实体
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        /// <returns></returns>
        public Fyp_3TierCommon.Model.Model_DEPARTMENT GetModel(int? DEPARTMENT_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select DEPARTMENT_ID, COMPANY_ID, DEPARTMENT_NAME from [DEPARTMENT]");
            strSql.Append(" where [DEPARTMENT_ID] = @DEPARTMENT_ID");

            SqlParameter[] arrParameters = new SqlParameter[1];

            arrParameters[0] = new SqlParameter("@DEPARTMENT_ID", SqlDbType.Int, 10);
            arrParameters[0].Value = DEPARTMENT_ID;

            Fyp_3TierCommon.Model.Model_DEPARTMENT model = new Fyp_3TierCommon.Model.Model_DEPARTMENT();

            DataSet ds = new DataSet();;

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                ds = dbManager.GetDataSet(strSql.ToString(), arrParameters);
            }

            if(ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[0];

                if (dr["DEPARTMENT_ID"].ToString().Length > 0)
                    model.DEPARTMENT_ID = int.Parse(dr["DEPARTMENT_ID"].ToString());

                if (dr["COMPANY_ID"].ToString().Length > 0)
                    model.COMPANY_ID = int.Parse(dr["COMPANY_ID"].ToString());

                model.DEPARTMENT_NAME = dr["DEPARTMENT_NAME"].ToString();

                return model;
            }
            else
            {
                return null;
            }
        }
        #endregion

        #region 获取数据列表
        /// <summary>
        /// 获取数据列表 DataSet
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <returns></returns>
        public DataSet GetDataSet(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select DEPARTMENT_ID, COMPANY_ID, DEPARTMENT_NAME from [DEPARTMENT]");
            if(strWhere.Trim().Length > 0)
            {
                strSql.Append(" where " + strWhere);
            }

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                return dbManager.GetDataSet(strSql.ToString());
            }
        }

        /// <summary>
        /// 获取数据列表 DataTable
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <returns></returns>
        public DataTable GetDataTable(string strWhere)
        {
            return GetDataTable(strWhere, "");
        }

        /// <summary>
        /// 获取数据列表 DataTable
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <param name="strOrder">排序字段，如id desc，不包含order by</param>
        /// <returns></returns>
        public DataTable GetDataTable(string strWhere, string strOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select DEPARTMENT_ID, COMPANY_ID, DEPARTMENT_NAME from [DEPARTMENT]");
            if(strWhere.Trim().Length > 0)
                strSql.Append(" where " + strWhere);

            if (strOrder.Trim().Length > 0)
                strSql.Append(" order by " + strOrder);

            using (FypSystem.DBManager.SqlServer dbManager = new FypSystem.DBManager.SqlServer())

            {
                return dbManager.GetDataTable(strSql.ToString());
            }
        }
        #endregion 
    }
}